-- mm_src.lua: Source Control [nclok1405]
-- Mod Mission

-- Navpoints --

-- Cribs. This mission can be started from any newspaper clipboard so we'll need to find out which crib is the closest.
NAVPOINT_CRIBS = {
	"cribs_sr2_city_$HE_crib",
	"cribs_sr2_city_$DT_crib",
--	"cribs_sr2_city_$PI_crib",
	"cribs_sr2_city_$SR_crib",
--	"cribs_sr2_city_$RL_crib",
	"cribs_sr2_city_$SU_crib",
	"cribs_sr2_city_$AI_crib",
	"cribs_sr2_city_$SHQ",
--	"cribs_sr2_city_$SU_Dock",
--	"cribs_sr2_city_$SB_Dock",
--	"cribs_sr2_city_$AI_Hangar",
--	"cribs_sr2_city_$SB_Aisha",
	"cribs_sr2_city_$YT_ultor",
	"cribs_sr2_city_$PB_icon",
}

-- Phase 1 Box Locations
NAVPOINT_PHASE1_BOXES = {
	"mm_src_$N_phase1_box1",
	"mm_src_$N_phase1_box2",
	"mm_src_$N_phase1_box3",
	"mm_src_$N_phase1_box4",
}

-- Phase 2 Box Locations
NAVPOINT_PHASE2_BOXES = {
	"mm_src_$N_phase2_box1",
	"mm_src_$N_phase2_box2",
	"mm_src_$N_phase2_box3",
	"mm_src_$N_phase2_box4",
	"mm_src_$N_phase2_box5",
	"mm_src_$N_phase2_box6",
	"mm_src_$N_phase2_box7",
	"mm_src_$N_phase2_box8",
	"mm_src_$N_phase2_box9",
}

-- Triggers --

-- Phase 1 Box Triggers
TRIGGER_PHASE1_BOXES = {
	"mm_src_$T_phase1_box1",
	"mm_src_$T_phase1_box2",
	"mm_src_$T_phase1_box3",
	"mm_src_$T_phase1_box4",
}

-- Phase 2 Box Triggers
TRIGGER_PHASE2_BOXES = {
	"mm_src_$T_phase2_box1",
	"mm_src_$T_phase2_box2",
	"mm_src_$T_phase2_box3",
	"mm_src_$T_phase2_box4",
	"mm_src_$T_phase2_box5",
	"mm_src_$T_phase2_box6",
	"mm_src_$T_phase2_box7",
	"mm_src_$T_phase2_box8",
	"mm_src_$T_phase2_box9",
}

-- Groups --
GROUP_PHASE1 = "mm_src_$G_phase1"
GROUP_PHASE2 = "mm_src_$G_phase2"
GROUP_PHASE3 = "mm_src_$G_phase3"

-- NPCs --
NPC_PHASE1_GUARDS = {
	"mm_src_$C_phase1_box1_guard",
	"mm_src_$C_phase1_box2_guard",
	"mm_src_$C_phase1_box3_guard",
	"mm_src_$C_phase1_box4_guard",
}
NPC_MIKE = "mm_src_$C_mike"
NPC_THOMAS = "mm_src_$C_thomas"

-- Checkpoints --
CHECKPOINT_START = MISSION_START_CHECKPOINT
CHECKPOINT_INTRO_DONE = "CHECKPOINT_INTRO_DONE"
CHECKPOINT_PHASE1 = "CHECKPOINT_PHASE1"
CHECKPOINT_PHASE1_DONE = "CHECKPOINT_PHASE1_DONE"
CHECKPOINT_PHASE2 = "CHECKPOINT_PHASE2"
CHECKPOINT_PHASE2_WAREHOUSE = "CHECKPOINT_PHASE2_WAREHOUSE"
CHECKPOINT_PHASE3 = "CHECKPOINT_PHASE3"

-- HelpTexts --
HT_INTRO_1 = "[format][color:green]???[/format]: Hello. You're the leader of the Saints, right? My name is Mike. Listen. We need your help. We promise an awesome reward for this task."
HT_INTRO_2 = "[format][color:green]Mike[/format]: We were tracking down the whereabouts of the source code of our old game, that got lost during the collapse of our parent company."
HT_INTRO_3 = "[format][color:green]Mike[/format]: Recently we finally found the possible locations. Unfortunately, looks like they are now owned by the Ultor..."
HT_INTRO_4 = "[format][color:green]Mike[/format]: This is why we need your help. Go to the [format][color:teal]possible locations[/format] and find [format][color:green]the source code disk[/format]."
HT_PHASE1_DONE_1 = "[format][color:green]Mike[/format]: So, you could not find the disk here? Damn..."
HT_PHASE1_DONE_2 = "[format][color:green]Mike[/format]: However, we know about another potential location. I'll send you the [format][color:teal]location of a warehouse[/format] to your GPS."
HT_PHASE2_DONE = "[format][color:green]Mike[/format]: You found a disk labeled 'Saints Row 2 PC Source Code'? YES! Please bring it to [color:teal]our office[/format]!"
HT_END_1 = "[format][color:green]Mike[/format]: YES! You did it! You're our hero!"
HT_END_2 = "[format][color:green]Mike[/format]: We can now fix this god-awful Saints Row 2 PC version! It will take a while, but we'll make sure that the resulting product will become awesome!"
HT_END_3 = "Thanks for playing! Mod by nclok1405"

HT_START = "Go to the [format][color:teal]indicated location[/format]."
HT_PHASE1 = "Inspect [format][color:teal]the boxes[/format] and find [format][color:green]the disk[/format]."
HT_PHASE2 = "Go to the [format][color:teal]warehouse[/format]."
HT_PHASE3 = "Go to Mike's [format][color:teal]office[/format]."

HT_BOX_NONE = "You found nothing in the box."
HT_BOX_MONEY_500 = "You found $500 in the box!"
HT_BOX_MONEY_1000 = "You found $1,000 in the box!"
HT_BOX_MONEY_5000 = "You found $5,000 in the box!"
HT_BOX_BONE = "You found some human bones in the box."
HT_BOX_BODY = "You found some dead body in the box."
HT_BOX_DOPEFISH = "You found a dead Dopefish in the box."
HT_BOX_LOA = "You found an empty Loa Dust package."
HT_BOX_TRAP = "It's a trap!"
HT_BOX_DISK = "You found a disk labeled 'Saints Row 2 PC Source Code'!"

-- Others --
MISSION_NAME = "mm_src"

-- Variables --
Phase1TriggersInspected = 0
Phase2TriggersInspected = 0
Phase2TrapActivated = false
Phase2DiskFound = false

-- Main Mission Function
function mm_src_start(checkpoint, is_restart)
	local cp = checkpoint
	
	set_mission_author("nclok1405")
	
	-- Fade Out
	mission_start_fade_out()

	if cp == CHECKPOINT_START then
		-- Teleport players to the nearest crib on restart
		if is_restart then
			local crib = mm_src_find_nearest_crib()
			teleport_coop(crib, crib)
		end
		
		-- DEBUG TEMP
		--cp = CHECKPOINT_PHASE1_DONE
		--teleport_coop("mm_src_$N_phase2_near_warehouse", "mm_src_$N_phase2_near_warehouse")
	end
	
	if cp == CHECKPOINT_PHASE1 then
		group_create(GROUP_PHASE1, true)	-- Load enemies now
	end
	
	if cp == CHECKPOINT_PHASE2_WAREHOUSE then
		group_create(GROUP_PHASE2, true)	-- Load enemies now
	end
	
	mission_start_fade_in()
	-- Fade In

	if cp == CHECKPOINT_START then
		-- Intro convo
		mm_src_cellphone_intro()
		delay(1)
		
		cp = CHECKPOINT_INTRO_DONE
		mission_set_checkpoint(cp)
	end
	
	if cp == CHECKPOINT_INTRO_DONE then
		-- Guide player to the boxes
		mission_help_table(HT_START)
		
		group_create(GROUP_PHASE1)	-- Load enemies in background
		
		local nav = NAVPOINT_PHASE1_BOXES[1]
		
		minimap_icon_add_navpoint_radius(nav, MINIMAP_ICON_LOCATION, 150, nil, SYNC_ALL)
		mission_waypoint_add(nav, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 150) do
			-- Wait until the players reach the location
			thread_yield()
		end
		
		mission_waypoint_remove(SYNC_ALL)
		minimap_icon_remove_navpoint(nav, SYNC_ALL)
		
		cp = CHECKPOINT_PHASE1
		mission_set_checkpoint(cp)
	end
	
	if cp == CHECKPOINT_PHASE1 then
		-- Inspect the boxes
		mission_help_table(HT_PHASE1)
		
		for index, trigger in pairs(TRIGGER_PHASE1_BOXES) do
			on_trigger("mm_src_phase1_trigger", trigger)
			trigger_enable(trigger, true)
			marker_add_trigger(trigger, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
		end
		
		-- Wait until all boxes are inspected
		while Phase1TriggersInspected < sizeof_table(TRIGGER_PHASE1_BOXES) do
			thread_yield()
		end
		
		release_to_world(GROUP_PHASE1)	-- Release enemies
		
		delay(4)
		
		cp = CHECKPOINT_PHASE1_DONE
		mission_set_checkpoint(cp)
	end
	
	if cp == CHECKPOINT_PHASE1_DONE then
		-- All box inspected
		mm_src_cellphone_phase1_done()
		
		cp = CHECKPOINT_PHASE2
		mission_set_checkpoint(cp)
	end
	
	if cp == CHECKPOINT_PHASE2 then
		-- Guide player to the warehouse
		group_create(GROUP_PHASE2)	-- Load enemies in background
		
		mission_help_table(HT_PHASE2)
		
		local nav = "mm_src_$N_phase2_near_warehouse"
		
		minimap_icon_add_navpoint_radius(nav, MINIMAP_ICON_LOCATION, 100, nil, SYNC_ALL)
		mission_waypoint_add(nav, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 100) do
			-- Wait until the players reach the location
			thread_yield()
		end
		
		mission_waypoint_remove(SYNC_ALL)
		minimap_icon_remove_navpoint(nav, SYNC_ALL)
		
		--
		nav = "mm_src_$N_phase2_near_warehouse2"
		
		marker_add_navpoint(nav, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 5) do
			thread_yield()
		end
		
		marker_remove_navpoint(nav, SYNC_ALL)
		
		--
		nav = "mm_src_$N_phase2_entrance"
		
		marker_add_navpoint(nav, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 5) do
			thread_yield()
		end
		
		marker_remove_navpoint(nav, SYNC_ALL)
		
		cp = CHECKPOINT_PHASE2_WAREHOUSE
		mission_set_checkpoint(cp)
	end
	
	if cp == CHECKPOINT_PHASE2_WAREHOUSE then
		-- Fight in the warehouse
		mission_help_table(HT_PHASE1)
		
		for index, trigger in pairs(TRIGGER_PHASE2_BOXES) do
			on_trigger("mm_src_phase2_trigger", trigger)
			trigger_enable(trigger, true)
			marker_add_trigger(trigger, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
		end

		-- Set notoriety range
		notoriety_set_min("Police", 2)
		notoriety_set_max("Police", 5)

		-- Wait until the disk is found
		while not Phase2DiskFound do
			thread_yield()
		end

		-- Disable all triggers here
		for index, trigger in pairs(TRIGGER_PHASE2_BOXES) do
			on_trigger("", trigger)
			trigger_enable(trigger, false)
		end

		-- Release enemies
		release_to_world(GROUP_PHASE2)
		
		-- Set notoriety range
		notoriety_set_min("Police", 0)
		notoriety_set_max("Police", 5)

		delay(2)
		
		cp = CHECKPOINT_PHASE3
		mission_set_checkpoint(cp)
	end
	
	if cp == CHECKPOINT_PHASE3 then
		-- Escape to the office
		local nav = "mm_src_$N_phase3_office"
		
		minimap_icon_add_navpoint_radius(nav, MINIMAP_ICON_LOCATION, 80, nil, SYNC_ALL)
		mission_waypoint_add(nav, SYNC_ALL)
		
		group_create(GROUP_PHASE3, true)	-- Load NPCs
		turn_invulnerable(NPC_MIKE)
		turn_invulnerable(NPC_THOMAS)
		set_unrecruitable_flag(NPC_MIKE, true)
		set_unrecruitable_flag(NPC_THOMAS, true)
		
		audio_play(CELLPHONE_OUTGOING, "foley", true)
		
		delay(2)
		
		mission_help_table_nag(HT_PHASE2_DONE)
		
		delay(7)

		mission_help_table(HT_PHASE3)
		
		while (get_dist_closest_player_to_object(nav) > 80) do
			thread_yield()
		end

		mission_waypoint_remove(SYNC_ALL)
		minimap_icon_remove_navpoint(nav, SYNC_ALL)

		-- Remove notoriety
		notoriety_set_min("Police", 0)
		notoriety_set_max("Police", 0)
		notoriety_set("Police", 0)
		
		--
		nav = "mm_src_$N_phase3_office_guide1"
		
		minimap_icon_add_navpoint_radius(nav, MINIMAP_ICON_LOCATION, 30, nil, SYNC_ALL)
		marker_add_navpoint(nav, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 30) do
			thread_yield()
		end
		
		marker_remove_navpoint(nav, SYNC_ALL)
		minimap_icon_remove_navpoint(nav, SYNC_ALL)

		--
		nav = "mm_src_$N_phase3_office_guide2"
		
		marker_add_navpoint(nav, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 5) do
			thread_yield()
		end
		
		marker_remove_navpoint(nav, SYNC_ALL)
		
		--
		nav = "mm_src_$N_phase3_office_guide3"
		
		marker_add_navpoint(nav, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 3) do
			thread_yield()
		end
		
		marker_remove_navpoint(nav, SYNC_ALL)

		--
		nav = "mm_src_$N_phase3_office_guide4"
		
		marker_add_navpoint(nav, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 1) do
			thread_yield()
		end
		
		marker_remove_navpoint(nav, SYNC_ALL)

		--
		nav = "mm_src_$N_phase3_office_guide5"
		
		marker_add_navpoint(nav, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION, SYNC_ALL)
		
		while (get_dist_closest_player_to_object(nav) > 1.5) do
			thread_yield()
		end
		
		marker_remove_navpoint(nav, SYNC_ALL)

		-- Meet the NPCs
		audio_play("SYS_RACE_FINISH")
		
		marker_add_npc(NPC_MIKE, MINIMAP_ICON_PROTECT_ACQUIRE, INGAME_EFFECT_PROTECT_ACQUIRE, SYNC_ALL)
		
		turn_to_char(NPC_MIKE, LOCAL_PLAYER)
		turn_to_char(NPC_THOMAS, LOCAL_PLAYER)
		
		action_play(NPC_MIKE, "Compliment A")
		action_play(NPC_THOMAS, "Compliment B")
		
		mission_help_table_nag(HT_END_1)
		delay(7)
		mission_help_table_nag(HT_END_2)
		delay(7)
		mission_help_table_nag(HT_END_3)
		delay(3)
		
		marker_remove_npc(NPC_MIKE, SYNC_ALL)
	end
	
	mission_end_success(MISSION_NAME)
end

-- Called when the mission ends with a success
function mm_src_success()
end

-- Cleanup
function mm_src_cleanup()
	mission_waypoint_remove(SYNC_ALL)

	notoriety_set_min("Police", 0)
	notoriety_set_max("Police", 5)

	release_to_world(GROUP_PHASE1)
	release_to_world(GROUP_PHASE2)
	release_to_world(GROUP_PHASE3)

	for index, trigger in pairs(TRIGGER_PHASE1_BOXES) do
		on_trigger("", trigger)
		trigger_enable(trigger, false)
	end
	for index, trigger in pairs(TRIGGER_PHASE2_BOXES) do
		on_trigger("", trigger)
		trigger_enable(trigger, false)
	end
end

-- Find the closest crib
function mm_src_find_nearest_crib()
	local nearest_crib = "cribs_sr2_city_$SHQ"
	local best_dist = 10000000
	
	for index, crib in pairs(NAVPOINT_CRIBS) do
		local dist = get_dist(LOCAL_PLAYER, crib)
		
		if dist < best_dist then
			best_dist = dist
			nearest_crib = crib
		end
	end

	return nearest_crib
end

-- Intro
function mm_src_cellphone_intro()
	-- Have the phone ring
	audio_play(CELLPHONE_INCOMING, "foley", true)

	-- Wait until the player answers the phone
	while not character_is_ready_to_speak( LOCAL_PLAYER ) do
		thread_yield()
	end

	cellphone_animate_start_do()

	delay( 0.5 )

	while not character_is_ready_to_speak( LOCAL_PLAYER ) do
		thread_yield()
	end

	delay(1)
	mission_help_table_nag(HT_INTRO_1)
	delay(7)
	mission_help_table_nag(HT_INTRO_2)
	delay(7)
	mission_help_table_nag(HT_INTRO_3)
	delay(7)
	mission_help_table_nag(HT_INTRO_4)
	delay(7)
	
	cellphone_animate_stop_do()
end

-- Phase1 Box Inspected
function mm_src_phase1_trigger(triggerer_name, trigger_name)
	local r = rand_int(1,8)
	
	if r == 1 then
		mission_help_table_nag(HT_BOX_MONEY_500, "", "", sync_from_player(triggerer_name))
		cash_add(500, triggerer_name)
		audio_play_for_character("SYS_PICKUP_COLLECT", triggerer_name, "foley", false, false)
	elseif r == 2 then
		mission_help_table_nag(HT_BOX_MONEY_1000, "", "", sync_from_player(triggerer_name))
		cash_add(1000, triggerer_name)
		audio_play_for_character("SYS_PICKUP_COLLECT", triggerer_name, "foley", false, false)
	elseif r == 3 then
		mission_help_table_nag(HT_BOX_BONE, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	elseif r == 4 then
		mission_help_table_nag(HT_BOX_BODY, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	elseif r == 5 then
		mission_help_table_nag(HT_BOX_DOPEFISH, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	elseif r == 6 then
		mission_help_table_nag(HT_BOX_LOA, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	else
		mission_help_table_nag(HT_BOX_NONE, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	end
	
	on_trigger("", trigger_name)
	trigger_enable(trigger_name, false)
	marker_remove_trigger(trigger_name)
	
	-- Anger guards
	for index, npc in pairs(NPC_PHASE1_GUARDS) do
		if not character_is_dead(npc) then
			attack(npc)
		end
	end
	
	Phase1TriggersInspected = Phase1TriggersInspected + 1
end

-- Phase1 Done convo
function mm_src_cellphone_phase1_done()
	-- Wait until the player can use the phone
	while not character_is_ready_to_speak( LOCAL_PLAYER ) do
		thread_yield()
	end

	cellphone_animate_start_do()

	delay( 0.5 )

	-- Outgoing sound
	audio_play(CELLPHONE_OUTGOING, "foley", true)
	
	while not character_is_ready_to_speak( LOCAL_PLAYER ) do
		thread_yield()
	end

	delay(1)
	mission_help_table_nag(HT_PHASE1_DONE_1)
	delay(7)
	mission_help_table_nag(HT_PHASE1_DONE_2)
	delay(7)
	
	cellphone_animate_stop_do()
end

-- Phase2 Box Inspected
function mm_src_phase2_trigger(triggerer_name, trigger_name)
	local r = rand_int(1,10)
	
	-- In the case the player is unlucky, we make sure that the last box will always contains the disk
	if (r == 1) or (Phase2TriggersInspected >= sizeof_table(NAVPOINT_PHASE2_BOXES) - 1) then
		Phase2DiskFound = true
		mission_help_table_nag(HT_BOX_DISK, "", "", sync_from_player(triggerer_name))
		audio_play("SYS_RACE_FINISH")
	elseif r == 2 then
		mission_help_table_nag(HT_BOX_MONEY_500, "", "", sync_from_player(triggerer_name))
		cash_add(500, triggerer_name)
		audio_play_for_character("SYS_PICKUP_COLLECT", triggerer_name, "foley", false, false)
	elseif r == 3 then
		mission_help_table_nag(HT_BOX_MONEY_1000, "", "", sync_from_player(triggerer_name))
		cash_add(1000, triggerer_name)
		audio_play_for_character("SYS_PICKUP_COLLECT", triggerer_name, "foley", false, false)
	elseif r == 4 then
		mission_help_table_nag(HT_BOX_MONEY_5000, "", "", sync_from_player(triggerer_name))
		cash_add(5000, triggerer_name)
		audio_play_for_character("SYS_PICKUP_COLLECT", triggerer_name, "foley", false, false)
	elseif r == 5 then
		mission_help_table_nag(HT_BOX_BONE, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	elseif r == 6 then
		mission_help_table_nag(HT_BOX_BODY, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	elseif r == 7 then
		mission_help_table_nag(HT_BOX_DOPEFISH, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	elseif r == 8 then
		mission_help_table_nag(HT_BOX_LOA, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	elseif r == 9 then
		-- Only allow one trap
		if not Phase2TrapActivated then
			mission_help_table_nag(HT_BOX_TRAP, "", "", sync_from_player(triggerer_name))
			explosion_create("Car Bomb", triggerer_name, "", true)
			Phase2TrapActivated = true
		else
			mission_help_table_nag(HT_BOX_NONE, "", "", sync_from_player(triggerer_name))
			audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
		end
	else
		mission_help_table_nag(HT_BOX_NONE, "", "", sync_from_player(triggerer_name))
		audio_play_for_character("SYS_HUD_ACTIVATE", triggerer_name, "foley", false, false)
	end
	
	on_trigger("", trigger_name)
	trigger_enable(trigger_name, false)
	marker_remove_trigger(trigger_name)
	
	Phase2TriggersInspected = Phase2TriggersInspected + 1
end
